﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using System.Threading;

namespace PassingCrystalReportParameters
{
    public partial class InputPage : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                BindData();
            }

        }

        private void BindData()
        {
            var cities = new List<City>()
                             { 
                                 new City() { Name = "Aachen"},
                                 new City() { Name = "Bergamo"},
                                 new City() { Name = "Eugene"}
                             };
            ddlCities.DataSource = cities;
            ddlCities.DataTextField = "Name";
            ddlCities.DataValueField = "Name"; 
            ddlCities.DataBind();
        }

        protected void ShowReport(object sender, EventArgs e)
        {
            string reportPath = Server.MapPath("ReportByCustomerNumberAndCity.rpt"); 

            string customerNumber = txtCustomerNumber.Text.Trim();
            string selectedCity = ddlCities.SelectedValue;
         
            ReportDocument report = new ReportDocument();
            report.Load(reportPath);

            var parameterFieldDefinitions = report.DataDefinition.ParameterFields;
            var customerNumberParameter = parameterFieldDefinitions["CustomerNumber"];

            var parameterValues = customerNumberParameter.CurrentValues;

            var discreteCustomerNumber = new ParameterDiscreteValue {Value = customerNumber};

            parameterValues.Add(discreteCustomerNumber);

            customerNumberParameter.ApplyCurrentValues(parameterValues);

            CrystalReportViewer1.SelectionFormula = "{Customers.CustomerID} = {?CustomerNumber}";
            CrystalReportViewer1.ReportSource = report;
            CrystalReportViewer1.DataBind();
        
        }
    }
}
